#include "common.h"

struct tms tmss, tmss1, tmss2, tmss3, tmssencap, tmssapi;
struct shmbuffedit_t shmbuffedit;


void printfile(char *filename)
{
	int fd;
	char	first20[21];

	first20[20]='\0';

	bcopy (shmbuffedit.editable, first20, 20);

	printf("the first 20 char is %s\n", first20);

	if ( (fd=creat(filename, 0600))<0) 
	{
		printf("file creat error!\n");
		exit(-1);
	}

	close(fd);

	printf("mid file created\n");

	if ( (fd=open(filename, O_WRONLY))<0) 
	{
		printf("file open error!\n");
		exit(-1);
	}

	write(fd, shmbuffedit.editable, shmbuffedit.length);
	printf ("file length: %d \n", shmbuffedit.length);
	close(fd);
	printf("finish writing file\n"); 
}


int getstreamid()
{
	int						key, shmid;
	int						*shm;
	struct shmbuffedit_t	*shmtemp;

	key=SHMKEYbuffedit;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }

	shmtemp=(struct shmbuffedit_t *)shm;


	while (shmtemp->oktoedit==0)
		usleep(100); //nothing to edit yet, busy waiting


	bcopy(shm, &shmbuffedit, sizeof(struct shmbuffedit_t));

	shmtemp->oktoedit=0;  //set back for arinfsf to use

	/*printf("How many keyword? %d\n", shmbuffedit.realkwlistlen);
	printf("The keyword is %s\n", shmbuffedit.searchresult[0].keyword);
	printf("How many founds for this keyword in this stream? %d\n", shmbuffedit.searchresult[0].numofindex);
	printf("Where are they? %d%d\n", shmbuffedit.searchresult[0].offset[0], shmbuffedit.searchresult[0].offset[1]);
*/
	//printfile("index5.html");
	return (shmbuffedit.flowtable);
}



int keysearch(int streamid, int startpoint, char *key, int keylen, struct searchresult_t *searchresult)
{
	int offset;
	int no;
	int i;

	
	if (streamid!=shmbuffedit.flowtable)
		return (-1);

	no=-1;
	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		if (bcmp(key, shmbuffedit.searchresult[i].keyword, keylen)==0)
			no=i;
	}
	if (no==-1)
	{
		printf("The keyword u input is not in our service range\n");
		return(-2);
	}
	
	bcopy(&(shmbuffedit.searchresult[no]), searchresult, sizeof(struct searchresult_t));
	return (1);
	
}

int deletebyte(int startpoint, int len)
{
	char		temp[MAXPAYLOADUDP*MAXBuffNum];
	int			i, j;

	
	//printf("what is the startpoint? %d\n", startpoint);
	if (startpoint>=shmbuffedit.length)
	{
		printf("Over the shmbuffedit length limit! \n");
		return (-1);
	}

	if (startpoint+len>=shmbuffedit.length)
	{
		printf("Over the shmbuffedit length limit! \n");
		return (-1);
	}

	bcopy(shmbuffedit.editable+startpoint+len, temp, shmbuffedit.length-startpoint-len);
	bcopy(temp, shmbuffedit.editable+startpoint, shmbuffedit.length-startpoint-len);
	shmbuffedit.length-=len;

/*	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		for (j=0; j<shmbuffedit.searchresult[i].numofindex; j++)
		{
			if (shmbuffedit.searchresult[i].offset[j]>=startpoint+len)
				shmbuffedit.searchresult[i].offset[j]-=len;
			if ((shmbuffedit.searchresult[i].offset[j]<startpoint+len)&&
				(shmbuffedit.searchresult[i].offset[j]>=startpoint))
				shmbuffedit.searchresult[i].offset[j]=startpoint;
			//else don't need to change
		}
	}

*/			
	return (1);
}

int insertbyte(int startpoint, char *insertion, int len)
{
	char		temp[MAXPAYLOADUDP*MAXBuffNum];
	int			i, j;


	//printf("what is the startpoint? %d\n", startpoint);

	if (startpoint>=shmbuffedit.length)
	{
		printf("Starting point is over the shmbuffedit length limit! \n");
		return (-1);
	}

	if (shmbuffedit.length+len>=MAXPAYLOADUDP*MAXBuffNum)
	{
		printf("Over the shmbuffedit length limit after insertion! \n");
		return (-1);
	}

	bcopy(shmbuffedit.editable+startpoint, temp, shmbuffedit.length-startpoint);
	bcopy(insertion, shmbuffedit.editable+startpoint, len);
	bcopy(temp, shmbuffedit.editable+startpoint+len, shmbuffedit.length-startpoint);
	shmbuffedit.length+=len;

	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		for (j=0; j<shmbuffedit.searchresult[i].numofindex; j++)
		{
			if (shmbuffedit.searchresult[i].offset[j]>=startpoint)
				shmbuffedit.searchresult[i].offset[j]+=len;
			//else don't need to change
		}
	}



	return (1);
}


int sendstream(int streamid)
{
	int						key, shmid;
	int						*shm;
	struct shmbuffarout_t	*shmbuffarout;
	struct	chop_t			choptemp[MAXBuffNum];
	int						choptempsz;
	char					outgoingbuff[MAXPKSIZE];
	struct udp_t			udppk;
	struct	ipv6_t			ipv6pk;
	char					*c;
	int						i;
	int						udppksize;



	key=SHMKEYbuffarout;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }

	shmbuffarout=(struct shmbuffarout_t *)shm;


	if (streamid!=shmbuffedit.flowtable)
	{
		printf("no such streamid for edit\n");
		return (-1);
	}




	choptempsz=chop(shmbuffedit.editable, shmbuffedit.length, choptemp, MAXCHOPSIZE);



	for (i=0 ; i<choptempsz; i++) 
	{
		bcopy(choptemp[i].content, outgoingbuff, choptemp[i].len);
		udppksize=wrapudp(outgoingbuff, &udppk, choptemp[i].len, shmbuffedit.sourceport, shmbuffedit.destport);
		//printf("udp payload size: %d\n", udppksize-8);
		
		wrapipv6((char *)&udppk, &ipv6pk, udppksize, shmbuffedit.sourceaddr, shmbuffedit.destinaddr, shmbuffedit.flowtable, UDPH, shmbuffedit.filename);
		//printf("in sendstream: filename=%s, streamid=%d\n", shmbuffedit.filename, shmbuffedit.flowtable);

		//printf("streamid: %d,  ipv6 size: %d\n", ipv6pk.flowtable, ipv6pk.payloadlen);


		if (shmbuffarout->shmrealsize>MAXBuffNum-1)
			printf("In apiedif: shmbuffarout full, wait to clear...\n");
		while (shmbuffarout->shmrealsize>MAXBuffNum-1)
			usleep(100); //wait to clear buffer

		if (shmbuffarout->shmwriting==1)
			printf("shmbuffarout is writing, wait...\n");
		while (shmbuffarout->shmwriting==1)
			usleep(100); //busy waiting;

		shmbuffarout->shmwriting=1;  //lockout

		c=(shmbuffarout->shmbuff)+MAXPKSIZE*(shmbuffarout->shmrealsize);
		bcopy(&ipv6pk, c, MAXPKSIZE);
		(shmbuffarout->shmrealsize)++;
		
		shmbuffarout->shmwriting=0;  //release lock
		
	}

	return (0);

}




int main()
{
	int streamid;
	int offset;
	int string0len, string1len;
	struct searchresult_t searchresult0, searchresult1;
	int i;
	int fd;
	int temp;
	int temp0, temp1;

	int count;

	int result0, result1;

	char	string0[]="<AD>";
	char	string1[]="</AD>";


	tmssencap.tms_utime=0;
	tmssencap.tms_stime=0;
	tmssapi.tms_utime=0;
	tmssapi.tms_stime=0;



	string1len=strlen(string1);
	string0len=strlen(string0);

	count=0;
	for (; ; )
	{
		times(&tmss1);
		printf("tmss1: total: utime=%d, stime=%d, total=%d\n", tmss1.tms_utime, tmss1.tms_stime, (int)tmss1.tms_utime+(int)tmss1.tms_stime);
		

		streamid=getstreamid();

		result0=keysearch(streamid, 0, string0, string0len, &searchresult0);
		result1=keysearch(streamid, 0, string1, string1len, &searchresult1);

		if ((result0<0)||(result1<0))
		{
			printf("keyword0 or keyword1 not found\n");
		}
		else if (searchresult0.numofindex!=searchresult1.numofindex)
		{
			printf("%s and %s not match\n", string0, string1);
		}
		else			 
		{
			printf("keyword %s and %s found and matched\n", string0, string1);
			for (i=0; i<searchresult0.numofindex; i++)
			{
				temp=searchresult0.offset[i];
				printf("%d  and  ", temp);
			}
			printf("\n"); 

			for (i=0; i<searchresult1.numofindex; i++)
			{
				temp=searchresult1.offset[i];
				printf("%d  and  ", temp);
			}
			printf("\n"); 

		
			for (i=searchresult0.numofindex-1; i>=0; i--)
			{
				temp0=searchresult0.offset[i];
				temp1=searchresult1.offset[i];

				if (temp1>temp0)
				{
					deletebyte(temp0, temp1-temp0+string1len);
				}

			}

		}

	//printfile("index3.html");

		times(&tmss2);
		printf("tmss2: utime=%d, stime=%d, total=%d\n",tmss2.tms_utime, tmss2.tms_stime, tmss2.tms_utime+tmss2.tms_stime);


		sendstream(streamid);

		times(&tmss3);
		printf("tmss3: utime=%d, stime=%d, total=%d\n",tmss3.tms_utime, tmss3.tms_stime, tmss3.tms_utime+tmss3.tms_stime);
		

		tmssapi.tms_utime+=(tmss2.tms_utime-tmss1.tms_utime);
		tmssapi.tms_stime+=(tmss2.tms_stime-tmss1.tms_stime);
		tmssencap.tms_utime+=(tmss3.tms_utime-tmss2.tms_utime);
		tmssencap.tms_stime+=(tmss3.tms_stime-tmss2.tms_stime);
		
		printf("api: utime=%d, stime=%d, total=%d\n", tmssapi.tms_utime, tmssapi.tms_stime, tmssapi.tms_utime+tmssapi.tms_stime);
		printf("encap: utime=%d, stime=%d, total=%d\n", tmssencap.tms_utime, tmssencap.tms_stime, tmssencap.tms_utime+tmssencap.tms_stime);

		count++;

		times(&tmss);
		printf("file#%d: total: utime=%d, stime=%d, total=%d\n\n", count, tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
		

	}

	return(0);
}




	
