#include "common.h"

struct pkq_t		pkque[MAXQNum];
struct tms tmss, tmss0, tmss1, tmss2, tmssrri, tmssdecap;


int streamctrl (char *in, struct keywordlist_t *keywordlist, struct shmbuffarout_t *shmbuffarout)
{
	struct ipv6_t	ip6buff;
	char			keytemp[MAXKEYWORDLEN];
	int				keytemplen;
	int				i;

	decapip6(in, &ip6buff, MAXPKSIZE);
	if (ip6buff.nextheader==UDPH) //only forward
	{
		if (shmbuffarout->shmrealsize>MAXBuffNum-1)
			printf("In arinedif: shmbuffarout overflow, wait to clear...\n");
		while (shmbuffarout->shmrealsize>MAXBuffNum-1)
			usleep(100); //wait to clear

		if (shmbuffarout->shmwriting==1)
			printf("In arinedif: somebody else is writing, wait...\n");
		while (shmbuffarout->shmwriting==1)
			usleep(100); //busy waiting

		shmbuffarout->shmwriting=1; //lock out
		bcopy(in, ((shmbuffarout->shmbuff)+(shmbuffarout->shmrealsize)*MAXPKSIZE), MAXPKSIZE);
		(shmbuffarout->shmrealsize)++;
		shmbuffarout->shmwriting=0; //release lock

		return (-1);
	}
	
	if (ip6buff.nextheader==EDIPH)
	{
		keytemplen=((struct ediph_t *)ip6buff.payload)->keylen;
		bcopy(((struct ediph_t *)ip6buff.payload)->keyword, keytemp, keytemplen); 

		for (i=0; i<keywordlist->num; i++)
		{
			if (bcmp(keytemp, keywordlist->keyword[i], keytemplen)==0)
			{
				
				return(inqueue(in));
			}
		}
		//keyword not in list, so forward directly

		if (shmbuffarout->shmrealsize>MAXBuffNum-1)
			printf("In arinedif: shmbuffarout overflow, wait to clear...\n");
		while (shmbuffarout->shmrealsize>MAXBuffNum-1)
			usleep(100); //wait to clear

		if (shmbuffarout->shmwriting==1)
			printf("In arinedif: somebody else is writing, wait...\n");
		while (shmbuffarout->shmwriting==1)
			usleep(100); //busy waiting

		shmbuffarout->shmwriting=1; //lock out
		bcopy(in, ((shmbuffarout->shmbuff)+(shmbuffarout->shmrealsize)*MAXPKSIZE), MAXPKSIZE);
		(shmbuffarout->shmrealsize)++;
		shmbuffarout->shmwriting=0; //release lock
		return(-1);
	}
	return (-1);
}


int inqueue (char * incomingbuff)
{
	struct ipv6_t	ip6temp;
	struct udp_t	*udptemp;
	int				i, destq;
	char			*temp;

	decapip6(incomingbuff, &ip6temp, MAXPKSIZE);

	//printf("InQue: version%d, traf_class %d, streamid %d, len:%d, nexthdr%d\n", ip6temp.version, ip6temp.traf_class, ip6temp.flowtable, ip6temp.payloadlen, ip6temp.nextheader);
	
	destq=-1;

	for (i=0; i<MAXQNum; i++) //find an queue with same streamid
	{
		if ((ip6temp.flowtable==pkque[i].streamid)&&(pkque[i].numofpkg>0))
		{
			destq=i;
			break;
		}
	}

	if (destq==-1) //try to locate a new queue
	{
		for (i=0; i<MAXQNum; i++)
		{
			if (pkque[i].numofpkg==0)
			{
				destq=i;
				pkque[destq].streamid=ip6temp.flowtable;
				break;
			}
		}
	}

	if (destq==-1) //run out of queues
	{
		printf("Run out of queues! Increase MAXQNum!\n");
		return (-1);
	}

	bcopy(&ip6temp, &pkque[destq].quepkg[pkque[destq].numofpkg], MAXPKSIZE);  //in queue
	pkque[destq].numofpkg++;  //update numofpkg
	if (pkque[destq].numofpkg>MAXBuffNum)  //check overflow
	{
		printf("InQueue: Queue is not long enough, increase MAXBuffNum\n");
		return (-2);
	}

	temp=ip6temp.payload;
	while(((struct ediph_t *)temp)->nextheader==EDIPH)
		temp+=sizeof(struct ediph_t);
	udptemp=(struct udp_t *)(temp+sizeof(struct ediph_t)); //only allow multi edip headers now
	
	//printf("InQueue: UDP payload length: %d\n", udptemp->length);
	if (udptemp->length==0)   //end of stream
	pkque[destq].complete=1;

	return (destq);

}



void moveque(int destq, struct shmbuffedit_t * shmbuffedit)
{
	int i;
	struct ipv6_t	ip6buff;
	struct udp_t	udpbuff;
	char			edippayload[MAXPKSIZE];
	struct ediph_t	ediphtemp;
	char			*temp;
	int				templen;
	int				nextheader;

	shmbuffedit->length=0;

	for (i=0; i<pkque[destq].numofpkg;i++)
	{
		bcopy(&(pkque[destq].quepkg[i]), &ip6buff, MAXPKSIZE); //=decapip6 
		if (ip6buff.nextheader==EDIPH)
		{
			bcopy(ip6buff.payload, &ediphtemp, sizeof(struct ediph_t));
			nextheader=decapedip(ip6buff.payload, shmbuffedit, edippayload, ip6buff.payloadlen, i);
			temp=ip6buff.payload+sizeof(struct ediph_t);
			templen=ip6buff.payloadlen-sizeof(struct ediph_t);
			while (nextheader==EDIPH)
			{
				nextheader=decapedip(temp, shmbuffedit, edippayload, templen, i);
				temp+=sizeof(struct ediph_t);
				templen-=sizeof(struct ediph_t);
			}
			//printf("in moveque: shmlength%d, realkwlistlen%d, numofindex for keyword[0]%d\n", shmbuffedit->length, shmbuffedit->realkwlistlen, shmbuffedit->searchresult[0].numofindex);
	
		}

		decapudp(edippayload, &udpbuff, templen); //templen equals to the last edippayload length
		bcopy(udpbuff.payload, (shmbuffedit->editable)+(shmbuffedit->length), udpbuff.length);
		shmbuffedit->length+=udpbuff.length;

	}


	strcpy (shmbuffedit->destinaddr, ip6buff.destinaddr);
	strcpy (shmbuffedit->sourceaddr, ip6buff.sourceaddr);
	shmbuffedit->destport=udpbuff.destport;
	shmbuffedit->sourceport=udpbuff.sourceport;
	shmbuffedit->flowtable=ip6buff.flowtable;
	shmbuffedit->loplimit=ip6buff.loplimit;
	shmbuffedit->nextheader=ip6buff.nextheader;
	shmbuffedit->traf_class=ip6buff.traf_class;
	shmbuffedit->version=ip6buff.version;
	shmbuffedit->oktoedit=1;
	strcpy(shmbuffedit->filename, ip6buff.filename);
	pkque[destq].complete=0;
	pkque[destq].streamid=-1;
	pkque[destq].numofpkg=0;


}


int main(int argc, char **argv)
{
	int					listenfd, connfd;
	socklen_t			len;
	struct sockaddr_in	servaddr, cliaddr;
	char				buff[MAXLINE];
	char				incomebuff[MAXPKSIZE];
	time_t				ticks;
	int					shmid;
    key_t				key;
    int					*shm;
	int					i, destq;
	int					fd;
	struct shmbuffedit_t *shmbuffedit;
	struct ipv6_t		ip6buff;
	struct udp_t		udpbuff;
	struct	shmbuffarout_t	*shmbuffarout;

	struct keywordlist_t	keywordlist;
	int					count;



	tmssrri.tms_utime=0;
	tmssrri.tms_stime=0;
	tmssdecap.tms_utime=0;
	tmssdecap.tms_stime=0;



	keywordlist.num=0;

	strcpy(keywordlist.keyword[0], "<AD>");
	keywordlist.num++;
	strcpy(keywordlist.keyword[1], "</AD>");
	keywordlist.num++;

	for (i=0; i<MAXQNum; i++)
	{
		pkque[i].numofpkg=0;
		pkque[i].complete=0;
	}



	key=SHMKEYbuffarout;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }
	shmbuffarout=(struct shmbuffarout_t *)shm;

	key=SHMKEYbuffedit;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }
	shmbuffedit=(struct shmbuffedit_t *)shm;

	
	if ( (listenfd = socket(AF_INET, SOCK_STREAM, 0))<0)
	{
		printf("Socket creation error! Program exit!\n");
		exit (-1);
	}

	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family      = AF_INET;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	servaddr.sin_port        = htons(RouterListenPort);	

	if (bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr))<0)
	{
		printf("Binding error! Program exit!\n");
		exit(-1);
	}

	listen(listenfd, LISTENQ);

	count=0;
	for ( ; ; ) 
	{
		times(&tmss0);

		len = sizeof(cliaddr);
		connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &len);
		//printf("connection from %s, port %d\n",
		//	   inet_ntop(AF_INET, &cliaddr.sin_addr, buff, sizeof(buff)),
		//	   ntohs(cliaddr.sin_port));
		readn(connfd, incomebuff, MAXPKSIZE);
		close(connfd);
		count++;

		destq=streamctrl(incomebuff, &keywordlist, shmbuffarout);


		times(&tmss1);


		if ((destq>=0)&&(pkque[destq].complete==1))  //a stream complete, copy to shm
		{
			if (shmbuffedit->oktoedit==1)
				printf("Share memory for edit buffer is full, wait...\n");
			while (shmbuffedit->oktoedit==1)
				usleep(100); //busy waiting

			bzero(shmbuffedit, sizeof(struct shmbuffedit_t));

			moveque(destq, shmbuffedit);  //copy to share memory

		}


		times(&tmss2);

		tmssrri.tms_utime+=(tmss1.tms_utime-tmss0.tms_utime);
		tmssrri.tms_stime+=(tmss1.tms_stime-tmss0.tms_stime);
		tmssdecap.tms_utime+=(tmss2.tms_utime-tmss1.tms_utime);
		tmssdecap.tms_stime+=(tmss2.tms_stime-tmss1.tms_stime);

		if (count%100==0)
		{
			times(&tmss);

			printf("(pk#%d): total: utime=%d, stime=%d, total=%d\n", count, tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
			printf("      decap: utime=%d, stime=%d, total=%d\n", tmssdecap.tms_utime, tmssdecap.tms_stime, tmssdecap.tms_utime+tmssdecap.tms_stime);
			printf("      rri(regular routing IN: utime=%d, stime=%d, total=%d\n\n", tmssrri.tms_utime, tmssrri.tms_stime, tmssrri.tms_utime+tmssrri.tms_stime);
		}		


	}

	return (0);
}
