#include	"common.h"


int marker1 (char *in, int in_len, struct searchresult_t *searchresult)
{
	char	kwd[]="<AD>";
	int		offset;

	strcpy(searchresult->keyword, kwd);
	searchresult->keylen=strlen(kwd);
	
	//printf("In marker1: keywordlen=%d , streamlen=%d\n", strlen(kwd), in_len);


	searchresult->numofindex=0;

	for (offset=0; offset+strlen(kwd)<in_len; offset++)
	{
		if (bcmp(in+offset, kwd, strlen(kwd))==0)
		{
			//printf("In marker1: Keyword found at offset %d\n", offset);
			searchresult->offset[searchresult->numofindex]=offset;
			//printf("search result: keyword at %d\n", offset);
			(searchresult->numofindex)++;
			if ((searchresult->numofindex)>=MAXNUMOFFOUND)
			{
				printf("too many keyword found! \n");
				return (-1);
			}

		}
	}
	return (searchresult->numofindex);
}

int marker2 (char *in, int in_len, struct searchresult_t *searchresult)
{
	char	kwd[]="</AD>";
	int		offset;

	strcpy(searchresult->keyword, kwd);
	searchresult->keylen=strlen(kwd);
	
	//printf("In marker1: keywordlen=%d , streamlen=%d\n", strlen(kwd), in_len);


	searchresult->numofindex=0;

	for (offset=0; offset+strlen(kwd)<in_len; offset++)
	{
		if (bcmp(in+offset, kwd, strlen(kwd))==0)
		{
			//printf("In marker1: Keyword found at offset %d\n", offset);
			searchresult->offset[searchresult->numofindex]=offset;
			//printf("search result: keyword at %d\n", offset);
			(searchresult->numofindex)++;
			if ((searchresult->numofindex)>=MAXNUMOFFOUND)
			{
				printf("too many keyword found! \n");
				return (-1);
			}

		}
	}
	return (searchresult->numofindex);
}
	
int wrapedip(struct searchresult_t *searchresult, int currentpk, int nextheader, char *in, int in_len, char *out)
{
	struct ediph_t ediph;
	char	temp[MAXPKSIZE];
	int		i;
	
	//printf("in wrapedip, currentpk=%d\n", currentpk);
	if (searchresult->numofindex<=0)
	{
		bcopy(in, out, in_len);
		return(in_len);
	}

	ediph.nextheader=nextheader;
	ediph.version=0;
	ediph.checksum=0;
	ediph.reserved=0;
	ediph.keylen=0; //no keyword yet
	ediph.numofindex=0;

	for (i=0; i<searchresult->numofindex; i++)
	{
		if (searchresult->whichpk[i]==currentpk)
		{
			bcopy(searchresult->keyword, ediph.keyword, searchresult->keylen);
			ediph.keylen=searchresult->keylen;
			ediph.offset[ediph.numofindex]=searchresult->offsetinpk[i];
			//printf("in wrapedip: currentpk=%d, the %d th keyword at %d\n", currentpk, ediph.numofindex, searchresult->offsetinpk[i]);

			ediph.numofindex++;
		}
	}
	bcopy(in, temp, in_len);
	bcopy(&ediph, out, sizeof(struct ediph_t));
	bcopy(temp, out+sizeof(struct ediph_t), in_len);
	return (in_len+sizeof(struct ediph_t));
}


int	mysendstream(char *streamtosend, char *filename, int streamlen, struct shmbuffcp_t *shmbuffcp)
{
	int					udppksize;
	int					edippksize1, edippksize2;
	char				outgoingbuff[MAXPKSIZE];
	struct chop_t		choptemp[MAXBuffNum];
	int					choptempsz;
	uint16_t			streamid;
	
	struct ipv6_t		ipv6pk;
	struct udp_t		udppk;
	char				edippk1[MAXPKSIZE]; //char here, not struct
	char				edippk2[MAXPKSIZE];
	struct searchresult_t	searchresult1, searchresult2;

	int					i;
	char				*c;

	int					nextheader;

	marker1(streamtosend, streamlen, &searchresult1);
	marker2(streamtosend, streamlen, &searchresult2);
	//printf("Found %s %d times\n",searchresult.keyword, searchresult.numofindex);

	choptempsz=chop(streamtosend, streamlen, choptemp, MAXCHOPSIZE);

	//printf("in mysendstream, numofindex=%d\n", searchresult.numofindex);
	for (i=0; i<searchresult1.numofindex; i++)
	{
		searchresult1.whichpk[i]=searchresult1.offset[i]/MAXCHOPSIZE;
		searchresult1.offsetinpk[i]=searchresult1.offset[i]%MAXCHOPSIZE;
		//printf("in mysendstream, the %d th found is at pk#%d, offset#%d\n", i, searchresult.whichpk[i], searchresult.offsetinpk[i]);
	}

	for (i=0; i<searchresult2.numofindex; i++)
	{
		searchresult2.whichpk[i]=searchresult2.offset[i]/MAXCHOPSIZE;
		searchresult2.offsetinpk[i]=searchresult2.offset[i]%MAXCHOPSIZE;
		//printf("in mysendstream, the %d th found is at pk#%d, offset#%d\n", i, searchresult.whichpk[i], searchresult.offsetinpk[i]);
	}

	usleep(10000); //try to get a new 1/100th second
	srand(times(NULL)); //gernate a random seed
	streamid=rand();
	//printf("random number %d\n", streamid);
	

	for (i=0 ; i<choptempsz; i++) 
	{
		bcopy(choptemp[i].content, outgoingbuff, choptemp[i].len);
		udppksize=wrapudp(outgoingbuff, &udppk, choptemp[i].len, SRCPORT, DSTPORT);
		//printf("udp payload size: %d\n", udppksize-8);
		edippksize1=wrapedip(&searchresult1, i, UDPH, (char*)&udppk, udppksize, edippk1);
		if (searchresult1.numofindex<=0)
			nextheader=UDPH;
		else nextheader=EDIPH;

		edippksize2=wrapedip(&searchresult2, i, nextheader, (char*)&edippk1, edippksize1, edippk2);
		if (searchresult2.numofindex<=0)
			nextheader=UDPH;
		else nextheader=EDIPH;		

		wrapipv6(edippk2,&ipv6pk, edippksize2, FROM_IP, 
TO_IP, streamid, nextheader, filename);
		//printf("streamid: %d,  ipv6 size: %d\n", ipv6pk.flowtable, ipv6pk.payloadlen);
		
		
		if (shmbuffcp->shmrealsize>MAXBuffNum-1)
			printf("Outgoing buffer overflow, wait to clear...\n");
		while (shmbuffcp->shmrealsize>MAXBuffNum-1)
			usleep(100);  //make it empty

		while (shmbuffcp->shmwriting==1)
			usleep(100); //busy waiting;
		shmbuffcp->shmwriting=1;

		c=(shmbuffcp->shmbuff)+MAXPKSIZE*(shmbuffcp->shmrealsize);
		bcopy(&ipv6pk, c, MAXPKSIZE);
		(shmbuffcp->shmrealsize)++;
		shmbuffcp->shmwriting=0;
		//printf("version:%d, ipv6 len: %d, shmrealsize %d\n", ((struct ipv6_t *)(shmbuffcp->shmbuff))->version, ((struct ipv6_t *)(shmbuffcp->shmbuff))->payloadlen, shmbuffcp->shmrealsize);

	}

	return (0);
}
	



int
main(int argc, char **argv)
{
	int					shmid;
    key_t				key;
    int					*shm;
	struct shmbuffcp_t	*shmbuffcp;
	char				*c;

	int					fd;
	int					fnamesd;

	char				streamtosend[MAXPKSIZE*MAXBuffNum];
	int					streamlen;

	char				filename[MAXFNAMELEN];
	int					fnamelen;

	int					count;



	key=SHMKEYcp;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(-1);
    }
    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(-1);
    }
	shmbuffcp=(struct shmbuffcp_t *)shm;

	count=0;

	
	if ( (fnamesd=open("./filenames.edif", O_RDONLY))<0)
	{
		printf("Filename file Open error!\n");
		exit(-1);
	}

	while ( (fnamelen=readline(fnamesd, filename, MAXFNAMELEN))>1)
	{
		filename[fnamelen-1]='\0'; //end the string with '\0' , not '\n'
		filename[fnamelen]='\0';
		filename[MAXFNAMELEN-1]='\0';
		//printf("the filenamelen is %d", fnamelen);
		//printf("the filename is %s\n", filename);
		if ( (fd=open(filename, O_RDONLY))<0)
		{
			printf("File Open error!\n");
			exit(-1);
		}
		streamlen=read(fd, streamtosend, MAXPKSIZE*MAXBuffNum);
		close (fd);
	
		if (streamlen>=MAXPKSIZE*MAXBuffNum)
			printf("Warning: File size exceed the limit! File may be trucated!\n");
		if (streamlen<=0)
		{
			printf("File size is zero or reading error!\n");
			exit (-1);
		}
		mysendstream(streamtosend, filename, streamlen, shmbuffcp);
		count++;
		printf("file#%d: %s is sent\n", count, filename);
		usleep(100000);
	}

	return (0);
}

